package org.expressolivre.cte.common;

import org.expressolivre.cte.pages.calendar.AppointmentPage;
import org.expressolivre.cte.pages.calendar.CalendarPage;
import org.expressolivre.cte.pages.calendar.CalendarTodayViewPage;
import org.expressolivre.cte.pages.common.HomePage;
import org.openqa.selenium.support.PageFactory;
import org.testng.annotations.BeforeMethod;

/**
 * @author L.F.Estivalet (Serpro)
 * 
 *         Created on Feb 8, 2011 at 9:16:54 AM
 * 
 */
public class BaseCalendarTestCase extends BaseTestCase {

	protected CalendarPage cp;

	/**
	 * Antes dos demais testes do modulo do calendario serem iniciados, este
	 * teste eh executado. Ele faz o login no Expresso e vai direto para a
	 * pagina incial. Depois clica-se no modulo Calendario para entao
	 * inicializar componentes da pagina.
	 */
	@BeforeMethod
	public void init() {
		HomePage hp = PageFactory.initElements(driver, HomePage.class);
		hp.enterCalendar();
		cp = PageFactory.initElements(driver, CalendarPage.class);
	}

	public CalendarTodayViewPage openTodayView() {
		cp.openTodayView();
		return PageFactory.initElements(driver, CalendarTodayViewPage.class);
	}

	public AppointmentPage newAppointment(String date) {
		cp.openAppointmentPage(date);
		return PageFactory.initElements(driver, AppointmentPage.class);
	}

	public AppointmentPage adicionarCompromisso(String data, String tipo,
			String titulo, String dataInicial, String horaInicial,
			String minutoInicial, String dataFinal, String horaFinal,
			String minutoFinal, String prioridade) {

		AppointmentPage ap = newAppointment(data);
		ap.setType(tipo);
		ap.setTitle(titulo);
		ap.setStartDate(dataInicial);
		ap.setStartHour(horaInicial);
		ap.setStartMinute(minutoInicial);
		ap.setEndDate(dataFinal);
		ap.setEndHour(horaFinal);
		ap.setEndMinute(minutoFinal);
		ap.setPriority(prioridade);

		return ap;
	}
}
