package org.expressolivre.cte.common;

import org.expressolivre.cte.pages.common.HomePage;
import org.expressolivre.cte.pages.email.MailAdminPreferencesPage;
import org.expressolivre.cte.pages.email.MailPage;
import org.expressolivre.cte.pages.email.MailPreferencesPage;
import org.openqa.selenium.support.PageFactory;
import org.testng.annotations.BeforeMethod;

/**
 * @author L.F.Estivalet (Serpro)
 * 
 *         Created on Jan 4, 2011 at 3:53:25 PM
 * 
 */
public class BaseEmailTestCase extends BaseTestCase {

	/** Contem os elementos da pagina de email que sao utilizados nos testes. */
	protected MailPage mp;

	/**
	 * Antes dos demais testes do modulo de email serem iniciados, este teste eh
	 * executado. Depois de fazer o login no Expresso, vai direto para a pagina
	 * incial. Depois clica-se no modulo ExpressoMail para entao inicializar
	 * componentes da pagina.
	 */
	@BeforeMethod
	public void init() {
		HomePage hp = PageFactory.initElements(driver, HomePage.class);
		hp.enterMail();
		mp = PageFactory.initElements(driver, MailPage.class);
	}

	/**
	 * Abre pagina de preferencias do modulo ExpressoMail
	 * 
	 * @return
	 */
	public MailPreferencesPage openEmailPreferencesPage() {
		driver.get(URL_PREFERENCES_EMAIL);
		return PageFactory.initElements(driver, MailPreferencesPage.class);
	}

	/**
	 * Abre pagina de preferencias administrativas do modulo ExpressoMail.
	 * 
	 * @return
	 */
	public MailAdminPreferencesPage openEmailAdminPreferencesPage() {
		driver.get(URL_PREFERENCES_EMAIL);
		return PageFactory.initElements(driver, MailAdminPreferencesPage.class);
	}

	/**
	 * Abre pagina de preferencias administrativas do modulo ExpressoMail.
	 * 
	 * @return
	 */
	public MailAdminPreferencesPage openEmailAdminDefaultPreferencesPage() {
		driver.get(URL_DEFAULT_PREFERENCES_EMAIL);
		return PageFactory.initElements(driver, MailAdminPreferencesPage.class);
	}

	/**
	 * Abre pagina de preferencias administrativas do modulo ExpressoMail.
	 * 
	 * @return
	 */
	public MailAdminPreferencesPage openEmailAdminForcedPreferencesPage() {
		driver.get(URL_FORCED_PREFERENCES_EMAIL);
		return PageFactory.initElements(driver, MailAdminPreferencesPage.class);
	}

}
